import binarysearchtree as BST


def usageExample2():
    
    IntroText = """
*****************************************************************
*   This is the SECOND introductory example.               ###  * 
*   It demonstrates basic BST processing using published  #   # *
*   methods of BinarySearchTree class.                        # *
*                                                            #  *
*   Compare the output, step by step,                       #   *
*   with the corresponding parts of the code.              #    *
*   Feel free to experiment and modify the example.       ##### *
*****************************************************************
"""
    print( IntroText )

    # Create a binary search tree, before any further manipulation.
    t = BST.BinarySearchTree()

    # Build a random BST with 17 nodes.
    t.randomBST( 17,   1, 30, 80, 99,  23581321 )

    # Use BST methods to assess the size of BST
    # and its depth.
    print( 'BST has', t.nNodes( t.root ), 'nodes.' )
    print( 'BST depth is', t.depth( t.root ), '.' )
     
    # Diplay the tree and check the results visually.
    t.display()
    
    # Delete a node, insert another node and see the result.
    # To delete a node, specify its key.
    t.delete( 21 )
    # To insert a node specify both its key and value.
    t.insert( 40, 400 )
    
    t.display()
    
# --------------------------------------------------------------------
#  RUN THE EXAMPLE
# --------------------------------------------------------------------

usageExample2()
